package com.bitmechanic.maxq;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class Preferences extends Properties
{
  private static final String PORT = "port";
  private static final String LIB_DIR = "libdir";

  private String prefsFile;

  public Preferences(String prefsFile)
  {
    this.prefsFile = prefsFile;
  }

  public void setPort(int port)
  {
    put(PORT, String.valueOf(port));
  }

  public int getPort()
  {
    return Integer.parseInt(getProperty(PORT));
  }

  public void setLibDir(String libDir)
  {
    put(LIB_DIR, libDir);
  }

  public String getLibDir()
  {
    return getProperty(LIB_DIR);
  }

  public void load() throws IOException
  {
    FileInputStream is = new FileInputStream(prefsFile);
    load(is);
    is.close();
  }

  public void save() throws IOException
  {
    FileOutputStream os = new FileOutputStream(prefsFile);
    store(os, "MaxQ Preferences");
    os.flush();
    os.close();
  }
}
