package com.bitmechanic.maxq;

import org.apache.commons.httpclient.HttpMethod;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.util.regex.Pattern;

/**
 * The class that does variuos validations on the requests and responses. This
 * class is tied to the driver class, com.bitmechanic.maxq.HttpTestCase.
 *
 * @author Hari
 */
public class Validator
{
  private static final Log log = LogFactory.getLog(Validator.class);

  private static String[] stdRspErrTags = new String[]{
            };
  private static String[] stdRspErrPats = new String[]{
            // "\\.\\w*Exception" // Java exception.
        };

  /**
   * Validate the response after the method has been executed.
   * params could be null.
   */
  public static void validateResponse(HttpTestCase test, HttpMethod
                                      httpMethod, String url, Object[] params)
  {
    log.debug("------Validator.validateResponse: method: " + httpMethod.getName() + " url: " + url + " params: " + params);

    // Detect if there are any error messages in the response.
    String response = httpMethod.getResponseBodyAsString();

    for (int i = 0; i < stdRspErrTags.length; ++i) {
      HttpTestCase.assertEquals("Standard invariant tag found in response: " +
              stdRspErrTags[i], -1, response.indexOf(stdRspErrTags[i]));
    }

    for (int i = 0; i < stdRspErrPats.length; ++i) {
      Pattern re = Pattern.compile(stdRspErrPats[i], Pattern.DOTALL);
      HttpTestCase.assertFalse("Standard invariant pattern found in response: " +
              stdRspErrPats[i], re.matcher(response).find());
    }
  }

  /**
   * Validate the request based on the previous response.
   * method is either "get" or "post".
   * httpMethod and params could be null.
   */
  public static void validateRequest(HttpTestCase test, HttpMethod httpMethod,
                                     String method, String url, Object[] params)
  {
    log.debug("------Validator.validateRequest: method: " + method +
            " url: " + url + " params: " + params);
  }
}
