package com.bitmechanic.maxq.generator;

import java.util.HashMap;

/**
 * Maps integer values to HttpStatus constant names
 * @author Musachy Barroso musachy@gmail.com
 */
public abstract class HttpStatusMap {
	private static final HashMap codes = new HashMap();
	
	static {
		//load codes
		codes.put(new Integer(202), "HttpStatus.SC_ACCEPTED");
		codes.put(new Integer(502), "HttpStatus.SC_BAD_GATEWAY");
		codes.put(new Integer(400), "HttpStatus.SC_BAD_REQUEST");
		codes.put(new Integer(409), "HttpStatus.SC_CONFLICT");
		codes.put(new Integer(100), "HttpStatus.SC_CONTINUE");
		codes.put(new Integer(201), "HttpStatus.SC_CREATED");
		codes.put(new Integer(417), "HttpStatus.SC_EXPECTATION_FAILED");
		codes.put(new Integer(424), "HttpStatus.SC_FAILED_DEPENDENCY");
		codes.put(new Integer(403), "HttpStatus.SC_FORBIDDEN");
		codes.put(new Integer(504), "HttpStatus.SC_GATEWAY_TIMEOUT");
		codes.put(new Integer(410), "HttpStatus.SC_GONE");
		codes.put(new Integer(505), "HttpStatus.SC_HttP_VERSION_NOT_SUPPORTED");
		codes.put(new Integer(419), "HttpStatus.SC_INSUFFICIENT_SPACE_ON_RESOURCE");
		codes.put(new Integer(507), "HttpStatus.SC_INSUFFICIENT_STORAGE");
		codes.put(new Integer(500), "HttpStatus.SC_INTERNAL_SERVER_ERROR");
		codes.put(new Integer(411), "HttpStatus.SC_LENGTH_REQUIRED");
		codes.put(new Integer(423), "HttpStatus.SC_LOCKED");
		codes.put(new Integer(420), "HttpStatus.SC_METHOD_FAILURE");
		codes.put(new Integer(405), "HttpStatus.SC_METHOD_NOT_ALLOWED");
		codes.put(new Integer(301), "HttpStatus.SC_MOVED_PERMANENTLY");
		codes.put(new Integer(302), "HttpStatus.SC_MOVED_TEMPORARILY");
		codes.put(new Integer(207), "HttpStatus.SC_MULTI_STATUS");
		codes.put(new Integer(300), "HttpStatus.SC_MULTIPLE_CHOICES");
		codes.put(new Integer(203), "HttpStatus.SC_NON_AUTHORITATIVE_INFORMATION");
		codes.put(new Integer(204), "HttpStatus.SC_NO_CONTENT");
		codes.put(new Integer(406), "HttpStatus.SC_NOT_ACCEPTABLE");
		codes.put(new Integer(404), "HttpStatus.SC_NOT_FOUND");
		codes.put(new Integer(501), "HttpStatus.SC_NOT_IMPLEMENTED");
		codes.put(new Integer(304), "HttpStatus.SC_NOT_MODIFIED");
		codes.put(new Integer(200), "HttpStatus.SC_OK");
		codes.put(new Integer(206), "HttpStatus.SC_PARTIAL_CONTENT");
		codes.put(new Integer(402), "HttpStatus.SC_PAYMENT_REQUIRED");
		codes.put(new Integer(412), "HttpStatus.SC_PRECONDITION_FAILED");
		codes.put(new Integer(102), "HttpStatus.SC_PROCESSING");
		codes.put(new Integer(407), "HttpStatus.SC_PROXY_AUTHENTICATION_REQUIRED");
		codes.put(new Integer(408), "HttpStatus.SC_REQUEST_TIMEOUT");
		codes.put(new Integer(413), "HttpStatus.SC_REQUEST_TOO_LONG");
		codes.put(new Integer(414), "HttpStatus.SC_REQUEST_URI_TOO_LONG");
		codes.put(new Integer(416), "HttpStatus.SC_REQUESTED_RANGE_NOT_SATISFIABLE");
		codes.put(new Integer(205), "HttpStatus.SC_RESET_CONTENT");
		codes.put(new Integer(303), "HttpStatus.SC_SEE_OTHER");
		codes.put(new Integer(503), "HttpStatus.SC_SERVICE_UNAVAILABLE");
		codes.put(new Integer(101), "HttpStatus.SC_SWITCHING_PROTOCOLS");
		codes.put(new Integer(307), "HttpStatus.SC_TEMPORARY_REDIRECT");
		codes.put(new Integer(401), "HttpStatus.SC_UNAUTHORIZED");
		codes.put(new Integer(422), "HttpStatus.SC_UNPROCESSABLE_ENTITY");
		codes.put(new Integer(215), "HttpStatus.SC_UNSUPPORTED_MEDIA_TYPE");
		codes.put(new Integer(305), "HttpStatus.SC_USE_PROXY");
	}
	
	public static String getHttpStatus(int code) {
		return (String)codes.get(new Integer(code)); 
	}
}
