package com.bitmechanic.maxq;

/**
 * Created by IntelliJ IDEA.
 * User: Wayne_Hearn
 * Date: Sep 15, 2003
 * Time: 2:42:01 PM
 * To change this template use Options | File Templates.
 */
public interface IScriptAdapter
{
  /**
   * Appends the given text to the end of the model.
   *
   * @param text - the text to append
   */
  public void append(String text);

  /**
   * Inserts the specified text at the specified position
   *
   * @param text     - the text to insert
   * @param position - starting position >= 0
   */
  public void insert(String text, int position);

  /**
   * Returns the text contained in the model
   * If the underlying model is null, will give a NullPointerException.
   *
   * @return - the text
   */
  public String getText();

  /**
   * Sets the text of this TextComponent to the specified text.
   * If the text is null or empty, has the effect of simply deleting the old text.
   *
   * @param text - the text to be set
   */
  public void setText(String text);

  /**
   * Replaces text from the indicated start to end position with the new text specified
   *
   * @param string the text to use as the replacement
   * @param start  - the start position >= 0
   * @param end    - the end position >= start
   * @throws IllegalArgumentException - if part of the range is an invalid position in the model
   */
  public void replace(String string, int start, int end) throws IllegalArgumentException;
}
