package com.bitmechanic.maxq;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;

public class PrefsDialog extends JDialog implements ActionListener
{
  private JButton okButton = new JButton("OK");
  private JButton cancelButton = new JButton("Cancel");

  private JTextField portField = new JTextField();
  private JTextField scriptDirField = new JTextField();

  private Preferences prefs;

  public PrefsDialog(Frame frame, Preferences prefs)
  {
    super(frame);
    this.prefs = prefs;

    portField.setText(String.valueOf(prefs.getPort()));
    scriptDirField.setText(prefs.getLibDir());

    setTitle("MaxQ Preferences");
    Dimension size = new Dimension(300, 200);
    setSize(size);

    // prevent user from using close box to exit dialog
    addWindowListener(new WindowAdapter()
    {
      public void windowClosing(WindowEvent we)
      {
        // no-op
      }
    });

    cancelButton.addActionListener(this);
    okButton.addActionListener(this);

    Container c = getContentPane();
    c.setLayout(new GridLayout(3, 2));
    c.add(new JLabel("Proxy Port:"));
    c.add(portField);
    c.add(new JLabel("Python Script Dir:"));
    c.add(scriptDirField);
    c.add(okButton);
    c.add(cancelButton);
  }

  public void actionPerformed(ActionEvent e)
  {
    Object source = e.getSource();

    if (source == cancelButton) {
      dispose();
    } else if (source == okButton) {
      // Save prefs
      try {
        prefs.setPort(Integer.parseInt(portField.getText()));
        prefs.setLibDir(scriptDirField.getText());
        prefs.save();
        dispose();
      } catch (IOException ex) {
        ex.printStackTrace();
      }
    }
  }

}
