package com.bitmechanic.maxq.generator;

import com.bitmechanic.maxq.HeaderValue;
import com.bitmechanic.maxq.IScriptAdapter;
import com.bitmechanic.maxq.Param;
import com.bitmechanic.maxq.Utils.UserException;

/**
 * This class implements the generator interface and simply outputs the
 * parameters of any calls that are made on it.  This is useful as a base
 * for new generator classes and for seeing what gets called when.
 */
public class SampleGenerator extends AbstractCodeGenerator
{
  //private boolean struts = false;
  
  public SampleGenerator(IScriptAdapter adapter)
  {
    super(adapter, new String[]{"^test name: (\\S+)"});
  }

  public void setStruts(boolean struts){
    // Not used
    //this.struts = struts;
  }
    
  private void wl(String s)
  {
    getScriptAdapter().append(s + EOL);
  }

  public void doNew()
  {
    wl("doNew()");
    wl(" test name: " + getDefaultTestName() + " [" + getClass().getName() + "]");
  }

  public String[] getValidFileExtensions()
  {
    return new String[]{".txt"};
  }

  public void doParameterList(Param[] params)
  {
    getScriptAdapter().append("doParameterList(");
    int i;
    for (i = 0; i < params.length; i++) {
      if (i != 0)
        getScriptAdapter().append(", ");
      getScriptAdapter().append(params[i].name + " = " + params[i].value);
    }
    wl(")");
  }

  public void doTestUrlMessage(String url)
  {
    wl("doTestUrlMessage(url = " + url + ")");
  }

  public void doSetData(String data)
  {
    wl("doSetData(data = " + data + ")");
  }

  public void doCallUrl(String url,
                        String method,
                        String data,
                        String contentLength)
  {
    wl("doCallUrl(url = " + url +
            ", method = " + method +
            ", data = " + data +
            ", contentLength = " + contentLength + ")");
  }

  public void doAssertResponse(String respCode)
  {
    wl("doAssertResponse(respCode = " + respCode + ")");
  }

  public void doTidyCode(String url)
  {
    wl("doTidyCode(url = " + url + ")");
  }

  public void doResponseForStdOut(String url)
  {
    wl("doResponseForStdOut(url = " + url + ")");
  }

  public void doResponseForFile()
  {
    wl("doResponseForFile()");
  }

  public void doEndTransaction()
  {
    wl("doEndTransaction()");
  }

  public void doSetCharset(String cs)
  {
    wl("doSetCharset("+cs+")");
  }
  
  public void doHeaders(HeaderValue[] headers)
  {
    //To change body of implemented methods use File | Settings | File Templates.
  }

  public void doStartRecording()
  {
    wl("doStartRecording()");
  }

  public void doStopRecording()
  {
    wl("doStopRecording()");
  }

  public void doClose()
  {
    wl("doClose()");
  }

  public void doQueryStringParameterList(Param[] params) throws UserException {
	wl("doQueryStringParameterList()");
  }

  public void doBodyParameterList(Param[] params) throws UserException {
	wl("doBodyParameterList()");
  }
}
