from sys import *
from java.lang import *
from java.io import *
from java.util import *
from org.apache.commons.httpclient import NameValuePair
from com.bitmechanic.maxq import Config
from PyHttpTestCase import PyHttpTestCase

global driverPkg, validatorPkg, logger
#if __name__ == 'main':
#    driverPkg = Config.getDriverPkgName()
#    validatorPkg = Config.getValidatorPkgName()

# Determine the validator for this testcase.
exec 'from '+Config.getValidatorPkgName()+' import Validator'


# Base class for tests generated using CompactGenerator.
class CompactTest(PyHttpTestCase):
    # Add setup code here.  See Junit javadoc.
    def setUp(self):
        pass

    # Add tearDown code here.  See Junit javadoc.
    def tearDown(self):
        pass

    def commonRequest(self, method, url, params, respCode):
        s = "%s" % self.replaceURL(url)
        if params is not None:
            first = 1
            s = s + " - "
            for key, value in params:
                if not first:
                    s = s + ', '
                s = s + key + '=' + value
                first = 0
        # The spaces make it easy to distinguish these run-of-the
        # mill messages from any user-inserted print statements.
        s = "  " + s  
        # This is just so users can see where they are up to.  Stop it wrapping
        # and messing up their view.
        if len(s) > 80:
            s = s[:77] + '...'
        self.msg(s)
                
        # Validate the request.  What is this?
        Validator.validateRequest(self, self.getMethod(), "get", url, params)
        
        # GET/POST
        method(self, url, params)
        
        # Validate the response.
        realCode = self.getMethod().getStatusCode()
        if respCode != realCode:
            raise "Expected response code %s but got %s\n%s" % (respCode, realCode, self.getResponse())
        Validator.validateResponse(self, self.getMethod(), url, params)
    
    def get(self, url, params, respCode):
        self.commonRequest(PyHttpTestCase.get, url, params, respCode)
        
    def post(self, url, params, respCode):
        self.commonRequest(PyHttpTestCase.post, url, params, respCode)

    def postMultiPart(self, url, params, respCode):
        # I only really want multipart for form data.
        self.commonRequest(PyHttpTestCase.post, url, params, respCode)
