package com.bitmechanic.maxq.test;

import com.bitmechanic.maxq.Config;
import com.bitmechanic.maxq.Main;
import junit.framework.TestCase;

public class MainTest extends TestCase
{
  private Config config = Config.getConfig();

  public void testPathSet() throws Exception
  {
    String[] args = {"--path", "\\foo\\bar"};
    Main.CommandLineResults results = new Main.CommandLineResults();
    Main.parseLine(args, results);
    assertEquals("\\foo\\bar", config.getPythonPath());
  }

  public void testShortPathSet() throws Exception
  {
    String[] args = {"-a", "\\foo\\bar"};
    Main.CommandLineResults results = new Main.CommandLineResults();
    Main.parseLine(args, results);
    assertEquals("\\foo\\bar", config.getPythonPath());
  }

  public void testPortUnSet() throws Exception
  {
    String[] args = {"-a", "\\foo\\bar"};
    Main.CommandLineResults results = new Main.CommandLineResults();
    Main.parseLine(args, results);
    assertEquals(8090, config.getPort());
  }

  public void testPort() throws Exception
  {
    String[] args = {"-p", "800"};
    Main.CommandLineResults results = new Main.CommandLineResults();
    Main.parseLine(args, results);
    assertEquals(800, config.getPort());
  }

  public void testWithTestList() throws Exception
  {
    String[] args = {"-r", "\\test.py", "\\foo.py"};
    Main.CommandLineResults results = new Main.CommandLineResults();
    Main.parseLine(args, results);
    assertEquals(2, results.tests.length);
    assertEquals("\\test.py", results.tests[0]);
    assertEquals("\\foo.py", results.tests[1]);
  }
}
