from sys import *

from com.bitmechanic.maxq import Config
global driverPkg, validatorPkg, logger
if __name__ == 'main':
    driverPkg = Config.getDriverPkgName()
    validatorPkg = Config.getValidatorPkgName()

# Determine the driver for this testcase.
exec 'from '+driverPkg+' import HttpTestCase'

# Determine the validator for this testcase.
exec 'from '+validatorPkg+' import Validator'

# imports
from junit.textui import TestRunner
from java.lang import *
from java.io import *
from java.util import *
from org.apache.commons.httpclient import NameValuePair


# definition of test class
class tigris(HttpTestCase):
    def __init__(self, testName):
        HttpTestCase.__init__(self, testName)

    # Add setup code here.  See Junit javadoc.
    def setUp(self):
        pass

    # Add tearDown code here.  See Junit javadoc.
    def tearDown(self):
        pass

    #Runs the test
    def runTest(self):
        self.doTest()

    #Test script
    def doTest(self):
        # Fetch a bug report. (GET with parameters)
        self.currentParams = [
            ('''id''', '''38''')]
        print "Testing URL: %s" % self.replaceURL('''http://maxq.tigris.org/issues/show_bug.cgi?id=38''')
        self.currentUrl = "http://maxq.tigris.org/issues/show_bug.cgi"
        list = self.currentParams
        Validator.validateRequest(self, self.getMethod(), "get", self.currentUrl, self.currentParams)
        self.get(self.currentUrl, list)
        print "Response code: %s" % self.getMethod().getStatusCode()
        self.assertEquals("Assert number 1 failed", 200, self.getMethod().getStatusCode())
        Validator.validateResponse(self, self.getMethod(), self.currentUrl, self.currentParams)

        # Go to the query screen. (GET with no parameters)
        print "Testing URL: %s" % self.replaceURL('''http://maxq.tigris.org/issues/query.cgi''')
        self.currentUrl = "http://maxq.tigris.org/issues/query.cgi"
        self.currentParams = None
        Validator.validateRequest(self, self.getMethod(), "get", self.currentUrl, self.currentParams)
        self.get(self.currentUrl)
        print "Response code: %s" % self.getMethod().getStatusCode()
        self.assertEquals("Assert number 4 failed", 200, self.getMethod().getStatusCode())
        Validator.validateResponse(self, self.getMethod(), self.currentUrl, self.currentParams)



##########################################

# Code to load and run the test
if __name__ == 'main':
    logger = Config.getTestLogger()
    test = tigris("tigris")
    test.Run()
